#ifndef __CANVAS_H__
#define __CANVAS_H__

#include <window/Window.h>
#include <list>

class Canvas{
public:
	Canvas(HDC hdc,int x,int y);
	~Canvas();

	HDC GetHDC(){return m_hdc;}
	void Copy(HDC hdc,ablib::window::Rect &rc);
	void SetLineStyle(ablib::window::rgb rgb,int width,ablib::window::Window::linetype style);
	void DrawLine(ablib::window::Point start,ablib::window::Point end);
	void SetFont(const TCHAR *fontname,int fontsize,int red,int green,int blue);
	void WriteText(ablib::window::Point pt,const TCHAR *str);
	void SetFillColor(ablib::window::rgb rgb);
	void FillRect(ablib::window::Rect rc);
	void AddUndoChain();
//	int GetLineWidth() const{return m_width;}
	int GetWidth(){return m_size.x;}
	int GetHeight(){return m_size.y;}

	bool Undo();
	bool Redo();

private:
	// {f[^
	HGDIOBJ m_oldobj;
	HDC m_hdc;
	HBITMAP m_bmp;
	ablib::window::Point m_size;

	// ̃X^C
	int m_width;
	ablib::window::Window::linetype m_linestyle;
	ablib::window::rgb m_rgb;
	HPEN m_pen;

	// tHg֘A
	ablib::string m_fontname;
	int m_fontsize;
	ablib::window::rgb m_fontrgb;
	HFONT m_font;
	HGDIOBJ m_oldfont;

	// hԂ悤
	HBRUSH m_fillbrush;
	HGDIOBJ m_oldfill;
	ablib::window::rgb m_fillcolor;

	// 蒼p
	std::list<HBITMAP> m_redoundo;
	std::list<HBITMAP>::iterator m_redoundostate;
	HDC m_tmphdc;

};

#endif //__CANVAS_H__

