#include "stdafx.h"
#include "TextBox.h"
#include "Ruby.h"

extern HINSTANCE g_appint;
extern Ruby g_Ruby;

//::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 0, ::GetLastError(),
//	MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), buf, 4095, 0);
TextBox::TextBox(int left, int top, int right, int bottom) : m_edit(NULL), m_handler(Qnil){
	HWND hwnd = ::CreateWindow(_T("EDIT"),NULL,WS_BORDER | WS_POPUP | ES_LEFT | ES_AUTOHSCROLL,
		left,top,right - left,bottom - top,
		NULL,0,g_appint,NULL);
	if(hwnd == NULL)return;
	ablib::window::Window wnd(hwnd);
	wnd.ShowWindow(ablib::window::Wnd::sw_show);
	::SetWindowLong(hwnd,GWL_EXSTYLE,(::GetWindowLong(hwnd,GWL_EXSTYLE) | WS_EX_TOOLWINDOW));
	::SetWindowPos(hwnd,HWND_TOPMOST,0,0,0,0,SWP_NOSIZE | SWP_NOMOVE);
	OUTPUTLASTERROR();
	wnd.SetForground();
	wnd.SetActive();
	wnd.SetFocus();
	m_edit = new ablib::window::Edit(&wnd);
	SubClass(m_edit->GetHWND());
}

void TextBox::SetSize(int left,int top,int right,int bottom){
	m_edit->Move(
		ablib::window::Point(left,top),
		ablib::window::Size(right - left,bottom - top));
}

bool TextBox::OnChar(ablib::window::Dialog *wnd, TCHAR ch, int repeat){
	return g_Ruby.Event_TextBox_OnChar(m_handler,ch);
}

bool TextBox::OnKey(ablib::window::Dialog *wnd, bool isDown, UINT vk, int repeat){
	if(isDown)return g_Ruby.Event_TextBox_OnKeyDown(m_handler,vk);
	else return g_Ruby.Event_TextBox_OnKeyUp(m_handler,vk);
}

void TextBox::Destroy(){
	::SendMessage(m_edit->GetHWND(),WM_CLOSE,0,0);
	UnSubClass();
//	if(m_edit){m_edit->Destroy(0);m_edit = NULL;}
}

