#ifndef __TEXTBOX_H__
#define __TEXTBOX_H__

#include <window/Dialog.h>
#include <window/SubClassWnd.h>
#include <ruby.h>

class Ruby;

class TextBox : public ablib::window::SubClassDlg{
public:
	TextBox(int left,int top,int right,int bottom);
	~TextBox(){if(m_edit){m_edit->Destroy(0);delete m_edit;}}
	bool IsCreated(){return m_edit != NULL;}
	void SetText(const TCHAR *str){m_edit->SetText(str);}
	ablib::string GetText(){return m_edit->GetText();}
	void SetSize(int left,int top,int right,int bottom);
	void Destroy();
	void SetEventHandler(VALUE handler){m_handler = handler;}

private:
	ablib::window::Edit *m_edit;
	VALUE m_handler;
	bool OnChar(ablib::window::Dialog *wnd,TCHAR ch,int repeat);
	bool OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk,int repeat);

	friend class Ruby;
};

#endif //__TEXTBOX_H__

